diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/netanim/model/animation-interface.cc ns-3.31/src/netanim/model/animation-interface.cc
--- ns-3.30.1/src/netanim/model/animation-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/netanim/model/animation-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -46,6 +46,7 @@
 #include "ns3/wimax-mac-header.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-mac.h"
+#include "ns3/wifi-psdu.h"
 #include "ns3/lr-wpan-mac-header.h"
 #include "ns3/lr-wpan-net-device.h"
 #include "ns3/constant-position-mobility-model.h"
@@ -74,19 +75,19 @@
 AnimationInterface::AnimationInterface (const std::string fn)
   : m_f (0),
     m_routingF (0),
-    m_mobilityPollInterval (Seconds (0.25)), 
+    m_mobilityPollInterval (Seconds (0.25)),
     m_outputFileName (fn),
-    gAnimUid (0), 
-    m_writeCallback (0), 
-    m_started (false), 
-    m_enablePacketMetadata (false), 
-    m_startTime (Seconds (0)), 
+    gAnimUid (0),
+    m_writeCallback (0),
+    m_started (false),
+    m_enablePacketMetadata (false),
+    m_startTime (Seconds (0)),
     m_stopTime (Seconds (3600 * 1000)),
-    m_maxPktsPerFile (MAX_PKTS_PER_TRACE_FILE), 
+    m_maxPktsPerFile (MAX_PKTS_PER_TRACE_FILE),
     m_originalFileName (fn),
-    m_routingStopTime (Seconds (0)), 
+    m_routingStopTime (Seconds (0)),
     m_routingFileName (""),
-    m_routingPollInterval (Seconds (5)), 
+    m_routingPollInterval (Seconds (5)),
     m_trackPackets (true)
 {
   initialized = true;
@@ -98,7 +99,7 @@
   StopAnimation ();
 }
 
-void 
+void
 AnimationInterface::SkipPacketTracing ()
 {
   m_trackPackets = false;
@@ -120,7 +121,7 @@
       UpdateNodeCounter (m_wifiPhyRxDropCounterId, n->GetId (), 0);
     }
   Simulator::Schedule (startTime, &AnimationInterface::TrackWifiPhyCounters, this);
- 
+
 }
 
 void
@@ -189,7 +190,7 @@
   Simulator::Schedule (startTime, &AnimationInterface::TrackIpv4L3ProtocolCounters, this);
 }
 
-AnimationInterface & 
+AnimationInterface &
 AnimationInterface::EnableIpv4RouteTracking (std::string fileName, Time startTime, Time stopTime, Time pollInterval)
 {
   SetOutputFile (fileName, true);
@@ -200,14 +201,14 @@
   return *this;
 }
 
-AnimationInterface & 
+AnimationInterface &
 AnimationInterface::EnableIpv4RouteTracking (std::string fileName, Time startTime, Time stopTime, NodeContainer nc, Time pollInterval)
 {
   m_routingNc = nc;
   return EnableIpv4RouteTracking (fileName, startTime, stopTime, pollInterval);
 }
 
-AnimationInterface & 
+AnimationInterface &
 AnimationInterface::AddSourceDestination (uint32_t fromNodeId, std::string ipv4Address)
 {
   Ipv4RouteTrackElement element = { ipv4Address, fromNodeId };
@@ -215,84 +216,84 @@
   return *this;
 }
 
-void 
+void
 AnimationInterface::SetStartTime (Time t)
 {
   m_startTime = t;
 }
 
-void 
+void
 AnimationInterface::SetStopTime (Time t)
 {
   m_stopTime = t;
 }
 
-void 
+void
 AnimationInterface::SetMaxPktsPerTraceFile (uint64_t maxPacketsPerFile)
 {
   m_maxPktsPerFile = maxPacketsPerFile;
 }
 
-uint32_t 
+uint32_t
 AnimationInterface::AddNodeCounter (std::string counterName, CounterType counterType)
 {
   m_nodeCounters.push_back (counterName);
   uint32_t counterId = m_nodeCounters.size () - 1; // counter ID is zero-indexed
   WriteXmlAddNodeCounter (counterId, counterName, counterType);
-  return counterId; 
+  return counterId;
 }
 
-uint32_t 
+uint32_t
 AnimationInterface::AddResource (std::string resourcePath)
 {
   m_resources.push_back (resourcePath);
   uint32_t resourceId = m_resources.size () -  1; // resource ID is zero-indexed
   WriteXmlAddResource (resourceId, resourcePath);
-  return resourceId; 
+  return resourceId;
 }
 
-void 
+void
 AnimationInterface::EnablePacketMetadata (bool enable)
 {
-   m_enablePacketMetadata = enable;
-   if (enable)
-     {
-       Packet::EnablePrinting ();
-     }
+  m_enablePacketMetadata = enable;
+  if (enable)
+    {
+      Packet::EnablePrinting ();
+    }
 }
 
-bool 
+bool
 AnimationInterface::IsInitialized ()
 {
   return initialized;
 }
 
-bool 
+bool
 AnimationInterface::IsStarted ()
 {
   return m_started;
 }
 
-void 
+void
 AnimationInterface::SetAnimWriteCallback (AnimWriteCallback cb)
 {
   m_writeCallback = cb;
 }
 
-void 
+void
 AnimationInterface::ResetAnimWriteCallback ()
 {
   m_writeCallback = 0;
 }
 
-void 
+void
 AnimationInterface::SetMobilityPollInterval (Time t)
 {
   m_mobilityPollInterval = t;
 }
 
 
-void 
+void
 AnimationInterface::SetConstantPosition (Ptr <Node> n, double x, double y, double z)
 {
   NS_ASSERT (n);
@@ -308,18 +309,18 @@
 
 }
 
-void 
+void
 AnimationInterface::UpdateNodeImage (uint32_t nodeId, uint32_t resourceId)
 {
   NS_LOG_INFO ("Setting node image for Node Id:" << nodeId);
-  if (resourceId > (m_resources.size ()-1))
+  if (resourceId > (m_resources.size () - 1))
     {
       NS_FATAL_ERROR ("Resource Id:" << resourceId << " not found. Did you use AddResource?");
     }
   WriteXmlUpdateNodeImage (nodeId, resourceId);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeCounter (uint32_t nodeCounterId, uint32_t nodeId, double counter)
 {
   if (nodeCounterId > (m_nodeCounters.size () - 1))
@@ -329,7 +330,7 @@
   WriteXmlUpdateNodeCounter (nodeCounterId, nodeId, counter);
 }
 
-void 
+void
 AnimationInterface::SetBackgroundImage (std::string fileName, double x, double y, double scaleX, double scaleY, double opacity)
 {
   if ((opacity < 0) || (opacity > 1))
@@ -339,7 +340,7 @@
   WriteXmlUpdateBackground (fileName, x, y, scaleX, scaleY, opacity);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeSize (uint32_t nodeId, double width, double height)
 {
   AnimationInterface::NodeSize s = { width, height };
@@ -347,45 +348,45 @@
   WriteXmlUpdateNodeSize (nodeId, s.width, s.height);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeColor (Ptr <Node> n, uint8_t r, uint8_t g, uint8_t b)
 {
   UpdateNodeColor (n->GetId (), r, g, b);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeColor (uint32_t nodeId, uint8_t r, uint8_t g, uint8_t b)
 {
   NS_ASSERT (NodeList::GetNode (nodeId));
-  NS_LOG_INFO ("Setting node color for Node Id:" << nodeId); 
+  NS_LOG_INFO ("Setting node color for Node Id:" << nodeId);
   Rgb rgb = {r, g, b};
   m_nodeColors[nodeId] = rgb;
   WriteXmlUpdateNodeColor (nodeId, r, g, b);
 }
 
-void 
+void
 AnimationInterface::UpdateLinkDescription (uint32_t fromNode, uint32_t toNode,
-                                                std::string linkDescription)
+                                           std::string linkDescription)
 {
   WriteXmlUpdateLink (fromNode, toNode, linkDescription);
 }
 
-void 
+void
 AnimationInterface::UpdateLinkDescription (Ptr <Node> fromNode, Ptr <Node> toNode,
-                                                std::string linkDescription)
+                                           std::string linkDescription)
 {
   NS_ASSERT (fromNode);
   NS_ASSERT (toNode);
   WriteXmlUpdateLink (fromNode->GetId (), toNode->GetId (), linkDescription);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeDescription (Ptr <Node> n, std::string descr)
 {
   UpdateNodeDescription (n->GetId (), descr);
 }
 
-void 
+void
 AnimationInterface::UpdateNodeDescription (uint32_t nodeId, std::string descr)
 {
   NS_ASSERT (NodeList::GetNode (nodeId));
@@ -396,7 +397,7 @@
 // Private methods
 
 
-double 
+double
 AnimationInterface::GetNodeEnergyFraction (Ptr <const Node> node) const
 {
   const EnergyFractionMap::const_iterator fractionIter = m_nodeEnergyFraction.find (node->GetId ());
@@ -404,17 +405,17 @@
   return fractionIter->second;
 }
 
-void 
+void
 AnimationInterface::MobilityCourseChangeTrace (Ptr <const MobilityModel> mobility)
 {
   CHECK_STARTED_INTIMEWINDOW;
   Ptr <Node> n = mobility->GetObject <Node> ();
   NS_ASSERT (n);
-  Vector v ;
+  Vector v;
   if (!mobility)
     {
       v = GetPosition (n);
-    } 
+    }
   else
     {
       v = mobility->GetPosition ();
@@ -423,13 +424,13 @@
   WriteXmlUpdateNodePosition (n->GetId (), v.x, v.y);
 }
 
-bool 
+bool
 AnimationInterface::NodeHasMoved (Ptr <Node> n, Vector newLocation)
 {
   Vector oldLocation = GetPosition (n);
   bool moved = true;
-  if ((ceil (oldLocation.x) == ceil (newLocation.x)) &&
-    (ceil (oldLocation.y) == ceil (newLocation.y)))
+  if ((ceil (oldLocation.x) == ceil (newLocation.x))
+      && (ceil (oldLocation.y) == ceil (newLocation.y)))
     {
       moved = false;
     }
@@ -440,7 +441,7 @@
   return moved;
 }
 
-void 
+void
 AnimationInterface::MobilityAutoCheck ()
 {
   CHECK_STARTED_INTIMEWINDOW;
@@ -450,7 +451,7 @@
       Ptr <Node> n = MovedNodes [i];
       NS_ASSERT (n);
       Vector v = GetPosition (n);
-      WriteXmlUpdateNodePosition (n->GetId () , v.x, v.y);
+      WriteXmlUpdateNodePosition (n->GetId (), v.x, v.y);
     }
   if (!Simulator::IsFinished ())
     {
@@ -464,7 +465,7 @@
     }
 }
 
-std::vector <Ptr <Node> >  
+std::vector <Ptr <Node> >
 AnimationInterface::GetMovedNodes ()
 {
   std::vector < Ptr <Node> > movedNodes;
@@ -495,7 +496,7 @@
   return movedNodes;
 }
 
-int 
+int
 AnimationInterface::WriteN (const std::string& st, FILE * f)
 {
   if (!f)
@@ -509,9 +510,9 @@
   return WriteN (st.c_str (), st.length (), f);
 }
 
-int 
+int
 AnimationInterface::WriteN (const char* data, uint32_t count, FILE * f)
-{ 
+{
   if (!f)
     {
       return 0;
@@ -523,7 +524,7 @@
   while (nLeft)
     {
       int n = std::fwrite (p, 1,  nLeft, f);
-      if (n <= 0) 
+      if (n <= 0)
         {
           return written;
         }
@@ -534,7 +535,7 @@
   return written;
 }
 
-void 
+void
 AnimationInterface::WriteRoutePath (uint32_t nodeId, std::string destination, Ipv4RoutePathElements rpElements)
 {
   NS_LOG_INFO ("Writing Route Path From :" << nodeId << " To: " << destination.c_str ());
@@ -551,25 +552,25 @@
   */
 }
 
-void 
+void
 AnimationInterface::WriteNonP2pLinkProperties (uint32_t id, std::string ipv4Address, std::string channelType)
 {
   WriteXmlNonP2pLinkProperties (id, ipv4Address, channelType);
 }
 
-const std::vector<std::string> 
+const std::vector<std::string>
 AnimationInterface::GetElementsFromContext (const std::string& context) const
 {
   std::vector <std::string> elements;
-  std::size_t pos1=0, pos2;
+  std::size_t pos1 = 0, pos2;
   while (pos1 != context.npos)
-  {
-    pos1 = context.find ("/",pos1);
-    pos2 = context.find ("/",pos1+1);
-    elements.push_back (context.substr (pos1+1,pos2-(pos1+1)));
-    pos1 = pos2; 
-    pos2 = context.npos;
-  }
+    {
+      pos1 = context.find ("/",pos1);
+      pos2 = context.find ("/",pos1 + 1);
+      elements.push_back (context.substr (pos1 + 1,pos2 - (pos1 + 1)));
+      pos1 = pos2;
+      pos2 = context.npos;
+    }
   return elements;
 }
 
@@ -599,7 +600,7 @@
   return n->GetDevice (atoi (elements.at (3).c_str ()));
 }
 
-uint64_t 
+uint64_t
 AnimationInterface::GetAnimUidFromPacket (Ptr <const Packet> p)
 {
   AnimByteTag tag;
@@ -625,7 +626,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::AddByteTag (uint64_t animUid, Ptr<const Packet> p)
 {
   AnimByteTag tag;
@@ -633,7 +634,7 @@
   p->AddByteTag (tag);
 }
 
-void 
+void
 AnimationInterface::RemainingEnergyTrace (std::string context, double previousEnergy, double currentEnergy)
 {
   CHECK_STARTED_INTIMEWINDOW;
@@ -730,7 +731,7 @@
   const Ptr <const Node> node = GetNodeFromContext (context);
   ++m_nodeIpv4Tx[node->GetId ()];
 }
- 
+
 void
 AnimationInterface::Ipv4RxTrace (std::string context, Ptr<const Packet> p, Ptr<Ipv4> ipv4, uint32_t interfaceIndex)
 {
@@ -739,11 +740,11 @@
 }
 
 void
-AnimationInterface::Ipv4DropTrace (std::string context, 
-                                   const Ipv4Header & ipv4Header, 
-                                   Ptr<const Packet> p, 
-                                   Ipv4L3Protocol::DropReason dropReason, 
-                                   Ptr<Ipv4> ipv4, 
+AnimationInterface::Ipv4DropTrace (std::string context,
+                                   const Ipv4Header & ipv4Header,
+                                   Ptr<const Packet> p,
+                                   Ipv4L3Protocol::DropReason dropReason,
+                                   Ptr<Ipv4> ipv4,
                                    uint32_t)
 {
   const Ptr <const Node> node = GetNodeFromContext (context);
@@ -768,19 +769,19 @@
 
 void
 AnimationInterface::QueueDropTrace (std::string context,
-                                  Ptr<const Packet> p)
+                                    Ptr<const Packet> p)
 {
   const Ptr <const Node> node = GetNodeFromContext (context);
   ++m_nodeQueueDrop[node->GetId ()];
 }
 
-void 
-AnimationInterface::DevTxTrace (std::string context, 
-                                     Ptr<const Packet> p,
-                                     Ptr<NetDevice> tx, 
-                                     Ptr<NetDevice> rx,
-                                     Time txTime, 
-                                     Time rxTime)
+void
+AnimationInterface::DevTxTrace (std::string context,
+                                Ptr<const Packet> p,
+                                Ptr<NetDevice> tx,
+                                Ptr<NetDevice> rx,
+                                Time txTime,
+                                Time rxTime)
 {
   NS_LOG_FUNCTION (this);
   CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
@@ -792,14 +793,14 @@
   double fbRx = (now + rxTime - txTime).GetSeconds ();
   double lbRx = (now + rxTime).GetSeconds ();
   CheckMaxPktsPerTraceFile ();
-  WriteXmlP ("p", 
-             tx->GetNode ()->GetId (), 
-             fbTx, 
-             lbTx, 
-             rx->GetNode ()->GetId (), 
-             fbRx, 
-             lbRx, 
-             m_enablePacketMetadata? GetPacketMetadata (p):"");
+  WriteXmlP ("p",
+             tx->GetNode ()->GetId (),
+             fbTx,
+             lbTx,
+             rx->GetNode ()->GetId (),
+             fbRx,
+             lbRx,
+             m_enablePacketMetadata ? GetPacketMetadata (p) : "");
 }
 
 void
@@ -819,16 +820,16 @@
 
   Ptr<WifiNetDevice> netDevice = DynamicCast<WifiNetDevice> (ndev);
   if (netDevice)
-    { 
+    {
       Mac48Address nodeAddr = netDevice->GetMac ()->GetAddress ();
-      std::ostringstream oss; 
+      std::ostringstream oss;
       oss << nodeAddr;
       Ptr <Node> n = netDevice->GetNode ();
       NS_ASSERT (n);
       m_macToNodeIdMap[oss.str ()] = n->GetId ();
-      NS_LOG_INFO ("Added Mac" << oss.str () << " node:" <<m_macToNodeIdMap[oss.str ()]);
+      NS_LOG_INFO ("Added Mac" << oss.str () << " node:" << m_macToNodeIdMap[oss.str ()]);
     }
-  AnimUidPacketInfoMap * pendingPackets =  ProtocolTypeToPendingPackets (protocolType); 
+  AnimUidPacketInfoMap * pendingPackets =  ProtocolTypeToPendingPackets (protocolType);
   OutputWirelessPacketTxInfo (p, pendingPackets->at (gAnimUid), gAnimUid);
 }
 
@@ -847,33 +848,64 @@
       NS_LOG_WARN (ProtocolTypeToString (protocolType).c_str () << " GenericWirelessRxTrace: unknown Uid");
       return;
     }
-  AnimUidPacketInfoMap * pendingPackets =  ProtocolTypeToPendingPackets (protocolType); 
+  AnimUidPacketInfoMap * pendingPackets =  ProtocolTypeToPendingPackets (protocolType);
   pendingPackets->at (animUid).ProcessRxBegin (ndev, Simulator::Now ().GetSeconds ());
   OutputWirelessPacketRxInfo (p, pendingPackets->at (animUid), animUid);
 }
 
-void 
+void
 AnimationInterface::UanPhyGenTxTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
   return GenericWirelessTxTrace (context, p, AnimationInterface::UAN);
 }
 
-void 
+void
 AnimationInterface::UanPhyGenRxTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
   return GenericWirelessRxTrace (context, p, AnimationInterface::UAN);
 }
 
-void 
-AnimationInterface::WifiPhyTxBeginTrace (std::string context, Ptr<const Packet> p, double txPowerW)
+void
+AnimationInterface::WifiPhyTxBeginTrace (std::string context, Ptr<const WifiPsdu> psdu, WifiTxVector txVector, double txPowerW)
 {
   NS_LOG_FUNCTION (this);
-  return GenericWirelessTxTrace (context, p, AnimationInterface::WIFI);
+  NS_UNUSED (txVector);
+  CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
+  Ptr<NetDevice> ndev = GetNetDeviceFromContext (context);
+  NS_ASSERT (ndev);
+  UpdatePosition (ndev);
+
+  AnimPacketInfo pktInfo (ndev, Simulator::Now ());
+  AnimUidPacketInfoMap * pendingPackets =  ProtocolTypeToPendingPackets (WIFI);
+  for (auto mpdu = psdu->begin (); mpdu != psdu->end (); ++mpdu)
+    {
+      ++gAnimUid;
+      NS_LOG_INFO ("WifiPhyTxTrace for MPDU:" << gAnimUid);
+      AddByteTag (gAnimUid, (*mpdu)->GetPacket ()); //the underlying MSDU/A-MSDU should be handed off
+      AddPendingPacket (WIFI, gAnimUid, pktInfo);
+      OutputWirelessPacketTxInfo ((*mpdu)->GetProtocolDataUnit (), pendingPackets->at (gAnimUid), gAnimUid); //PDU should be considered in order to have header
+    }
+
+  Ptr<WifiNetDevice> netDevice = DynamicCast<WifiNetDevice> (ndev);
+  if (netDevice)
+    {
+      Mac48Address nodeAddr = netDevice->GetMac ()->GetAddress ();
+      std::ostringstream oss;
+      oss << nodeAddr;
+      Ptr<Node> n = netDevice->GetNode ();
+      NS_ASSERT (n);
+      m_macToNodeIdMap[oss.str ()] = n->GetId ();
+      NS_LOG_INFO ("Added Mac" << oss.str () << " node:" << m_macToNodeIdMap[oss.str ()]);
+    }
+  else
+    {
+      NS_ABORT_MSG ("This NetDevice should be a Wi-Fi network device");
+    }
 }
 
-void 
+void
 AnimationInterface::WifiPhyRxBeginTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
@@ -882,24 +914,23 @@
   NS_ASSERT (ndev);
   UpdatePosition (ndev);
   uint64_t animUid = GetAnimUidFromPacket (p);
-  NS_LOG_INFO ("Wifi RxBeginTrace for packet:" << animUid);
+  NS_LOG_INFO ("Wifi RxBeginTrace for packet: " << animUid);
   if (!IsPacketPending (animUid, AnimationInterface::WIFI))
     {
-      NS_ASSERT (0);
-      NS_LOG_WARN ("WifiPhyRxBeginTrace: unknown Uid");
+      NS_ASSERT_MSG (false, "WifiPhyRxBeginTrace: unknown Uid");
       std::ostringstream oss;
       WifiMacHeader hdr;
       if (!p->PeekHeader (hdr))
-      { 
-        NS_LOG_WARN ("WifiMacHeader not present");
-        return;
-      }
+        {
+          NS_LOG_WARN ("WifiMacHeader not present");
+          return;
+        }
       oss << hdr.GetAddr2 ();
-      if (m_macToNodeIdMap.find (oss.str ()) == m_macToNodeIdMap.end ()) 
-      {
-        NS_LOG_WARN ("Transmitter Mac address " << oss.str () << " never seen before. Skipping");
-        return;
-      }
+      if (m_macToNodeIdMap.find (oss.str ()) == m_macToNodeIdMap.end ())
+        {
+          NS_LOG_WARN ("Transmitter Mac address " << oss.str () << " never seen before. Skipping");
+          return;
+        }
       Ptr <Node> txNode = NodeList::GetNode (m_macToNodeIdMap[oss.str ()]);
       UpdatePosition (txNode);
       AnimPacketInfo pktInfo (0, Simulator::Now (), m_macToNodeIdMap[oss.str ()]);
@@ -911,7 +942,7 @@
   OutputWirelessPacketRxInfo (p, m_pendingWifiPackets[animUid], animUid);
 }
 
-void 
+void
 AnimationInterface::LrWpanPhyTxBeginTrace (std::string context,
                                            Ptr<const Packet> p)
 {
@@ -929,10 +960,10 @@
 
   LrWpanMacHeader hdr;
   if (!p->PeekHeader (hdr))
-  {
-    NS_LOG_WARN ("LrWpanMacHeader not present");
-    return;
-  }
+    {
+      NS_LOG_WARN ("LrWpanMacHeader not present");
+      return;
+    }
 
   std::ostringstream oss;
   if (hdr.GetSrcAddrMode () == 2)
@@ -951,7 +982,7 @@
       return;
     }
   m_macToNodeIdMap[oss.str ()] = n->GetId ();
-  NS_LOG_INFO ("Added Mac" << oss.str () << " node:" <<m_macToNodeIdMap[oss.str ()]);
+  NS_LOG_INFO ("Added Mac" << oss.str () << " node:" << m_macToNodeIdMap[oss.str ()]);
 
   ++gAnimUid;
   NS_LOG_INFO ("LrWpan TxBeginTrace for packet:" << gAnimUid);
@@ -1011,21 +1042,20 @@
   NS_LOG_INFO ("Wave RxBeginTrace for packet:" << animUid);
   if (!IsPacketPending (animUid, AnimationInterface::WAVE))
     {
-      NS_ASSERT (0);
-      NS_LOG_WARN ("WavePhyRxBeginTrace: unknown Uid");
+      NS_ASSERT_MSG (false, "WavePhyRxBeginTrace: unknown Uid");
       std::ostringstream oss;
       WifiMacHeader hdr;
       if (!p->PeekHeader (hdr))
-      {
-        NS_LOG_WARN ("WaveMacHeader not present");
-        return;
-      }
+        {
+          NS_LOG_WARN ("WaveMacHeader not present");
+          return;
+        }
       oss << hdr.GetAddr2 ();
       if (m_macToNodeIdMap.find (oss.str ()) == m_macToNodeIdMap.end ())
-      {
-        NS_LOG_WARN ("Transmitter Mac address " << oss.str () << " never seen before. Skipping");
-        return;
-      }
+        {
+          NS_LOG_WARN ("Transmitter Mac address " << oss.str () << " never seen before. Skipping");
+          return;
+        }
       Ptr <Node> txNode = NodeList::GetNode (m_macToNodeIdMap[oss.str ()]);
       UpdatePosition (txNode);
       AnimPacketInfo pktInfo (0, Simulator::Now (), m_macToNodeIdMap[oss.str ()]);
@@ -1046,33 +1076,33 @@
 }
 
 
-void 
+void
 AnimationInterface::WimaxRxTrace (std::string context, Ptr<const Packet> p, const Mac48Address & m)
 {
   NS_LOG_FUNCTION (this);
   return GenericWirelessRxTrace (context, p, AnimationInterface::WIMAX);
 }
 
-void 
+void
 AnimationInterface::LteTxTrace (std::string context, Ptr<const Packet> p, const Mac48Address & m)
 {
   NS_LOG_FUNCTION (this);
   return GenericWirelessTxTrace (context, p, AnimationInterface::LTE);
 }
 
-void 
+void
 AnimationInterface::LteRxTrace (std::string context, Ptr<const Packet> p, const Mac48Address & m)
 {
   NS_LOG_FUNCTION (this);
   return GenericWirelessRxTrace (context, p, AnimationInterface::LTE);
 }
 
-void 
+void
 AnimationInterface::LteSpectrumPhyTxStart (std::string context, Ptr<const PacketBurst> pb)
 {
   NS_LOG_FUNCTION (this);
   CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
-  if (!pb) 
+  if (!pb)
     {
       NS_LOG_WARN ("pb == 0. Not yet supported");
       return;
@@ -1097,12 +1127,12 @@
     }
 }
 
-void 
+void
 AnimationInterface::LteSpectrumPhyRxStart (std::string context, Ptr<const PacketBurst> pb)
 {
   NS_LOG_FUNCTION (this);
   CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
-  if (!pb) 
+  if (!pb)
     {
       NS_LOG_WARN ("pb == 0. Not yet supported");
       return;
@@ -1131,7 +1161,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::CsmaPhyTxBeginTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
@@ -1149,7 +1179,7 @@
 
 }
 
-void 
+void
 AnimationInterface::CsmaPhyTxEndTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
@@ -1161,8 +1191,8 @@
   NS_LOG_INFO ("CsmaPhyTxEndTrace for packet:" << animUid);
   if (!IsPacketPending (animUid, AnimationInterface::CSMA))
     {
-      NS_LOG_WARN ("CsmaPhyTxEndTrace: unknown Uid"); 
-      NS_FATAL_ERROR ("CsmaPhyTxEndTrace: unknown Uid"); 
+      NS_LOG_WARN ("CsmaPhyTxEndTrace: unknown Uid");
+      NS_FATAL_ERROR ("CsmaPhyTxEndTrace: unknown Uid");
       AnimPacketInfo pktInfo (ndev, Simulator::Now ());
       AddPendingPacket (AnimationInterface::CSMA, animUid, pktInfo);
       NS_LOG_WARN ("Unknown Uid, but adding Csma Packet anyway");
@@ -1172,7 +1202,7 @@
   pktInfo.m_lbTx = Simulator::Now ().GetSeconds ();
 }
 
-void 
+void
 AnimationInterface::CsmaPhyRxEndTrace (std::string context, Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
@@ -1183,7 +1213,7 @@
   uint64_t animUid = GetAnimUidFromPacket (p);
   if (!IsPacketPending (animUid, AnimationInterface::CSMA))
     {
-      NS_LOG_WARN ("CsmaPhyRxEndTrace: unknown Uid"); 
+      NS_LOG_WARN ("CsmaPhyRxEndTrace: unknown Uid");
       return;
     }
   /// \todo NS_ASSERT (CsmaPacketIsPending (AnimUid) == true);
@@ -1194,9 +1224,9 @@
   OutputCsmaPacket (p, pktInfo);
 }
 
-void 
+void
 AnimationInterface::CsmaMacRxTrace (std::string context,
-                                         Ptr<const Packet> p)
+                                    Ptr<const Packet> p)
 {
   NS_LOG_FUNCTION (this);
   CHECK_STARTED_INTIMEWINDOW_TRACKPACKETS;
@@ -1205,7 +1235,7 @@
   uint64_t animUid = GetAnimUidFromPacket (p);
   if (!IsPacketPending (animUid, AnimationInterface::CSMA))
     {
-      NS_LOG_WARN ("CsmaMacRxTrace: unknown Uid"); 
+      NS_LOG_WARN ("CsmaMacRxTrace: unknown Uid");
       return;
     }
   /// \todo NS_ASSERT (CsmaPacketIsPending (AnimUid) == true);
@@ -1227,10 +1257,10 @@
     {
       nodeId = pktInfo.m_txNodeId;
     }
-  WriteXmlPRef (animUid, nodeId, pktInfo.m_fbTx, m_enablePacketMetadata? GetPacketMetadata (p):"");
+  WriteXmlPRef (animUid, nodeId, pktInfo.m_fbTx, m_enablePacketMetadata ? GetPacketMetadata (p) : "");
 }
 
-void 
+void
 AnimationInterface::OutputWirelessPacketRxInfo (Ptr<const Packet> p, AnimPacketInfo & pktInfo, uint64_t animUid)
 {
   CheckMaxPktsPerTraceFile ();
@@ -1238,7 +1268,7 @@
   WriteXmlP (animUid, "wpr", rxId, pktInfo.m_fbRx, pktInfo.m_lbRx);
 }
 
-void 
+void
 AnimationInterface::OutputCsmaPacket (Ptr<const Packet> p, AnimPacketInfo &pktInfo)
 {
   CheckMaxPktsPerTraceFile ();
@@ -1246,17 +1276,17 @@
   uint32_t nodeId = pktInfo.m_txnd->GetNode ()->GetId ();
   uint32_t rxId = pktInfo.m_rxnd->GetNode ()->GetId ();
 
-  WriteXmlP ("p", 
-             nodeId, 
-             pktInfo.m_fbTx, 
-             pktInfo.m_lbTx, 
+  WriteXmlP ("p",
+             nodeId,
+             pktInfo.m_fbTx,
+             pktInfo.m_lbTx,
              rxId,
-             pktInfo.m_fbRx, 
-             pktInfo.m_lbRx, 
-             m_enablePacketMetadata? GetPacketMetadata (p):"");
+             pktInfo.m_fbRx,
+             pktInfo.m_lbRx,
+             m_enablePacketMetadata ? GetPacketMetadata (p) : "");
 }
 
-void 
+void
 AnimationInterface::AddPendingPacket (ProtocolType protocolType, uint64_t animUid, AnimPacketInfo pktInfo)
 {
   AnimUidPacketInfoMap * pendingPackets = ProtocolTypeToPendingPackets (protocolType);
@@ -1264,7 +1294,7 @@
   pendingPackets->insert (AnimUidPacketInfoMap::value_type (animUid, pktInfo));
 }
 
-bool 
+bool
 AnimationInterface::IsPacketPending (uint64_t animUid, AnimationInterface::ProtocolType protocolType)
 {
   AnimUidPacketInfoMap * pendingPackets = ProtocolTypeToPendingPackets (protocolType);
@@ -1272,7 +1302,7 @@
   return (pendingPackets->find (animUid) != pendingPackets->end ());
 }
 
-void 
+void
 AnimationInterface::PurgePendingPackets (AnimationInterface::ProtocolType protocolType)
 {
   AnimUidPacketInfoMap * pendingPackets = ProtocolTypeToPendingPackets (protocolType);
@@ -1286,8 +1316,8 @@
        i != pendingPackets->end ();
        ++i)
     {
-     
-      AnimPacketInfo pktInfo = i->second; 
+
+      AnimPacketInfo pktInfo = i->second;
       double delta = (Simulator::Now ().GetSeconds () - pktInfo.m_fbTx);
       if (delta > PURGE_INTERVAL)
         {
@@ -1302,47 +1332,47 @@
     }
 }
 
-AnimationInterface::AnimUidPacketInfoMap * 
+AnimationInterface::AnimUidPacketInfoMap *
 AnimationInterface::ProtocolTypeToPendingPackets (AnimationInterface::ProtocolType protocolType)
 {
   AnimUidPacketInfoMap * pendingPackets = 0;
   switch (protocolType)
     {
-      case AnimationInterface::WIFI:
-        {
-          pendingPackets = &m_pendingWifiPackets;
-          break;
-        }
-      case AnimationInterface::UAN:
-        {
-          pendingPackets = &m_pendingUanPackets;
-          break;
-        }
-      case AnimationInterface::CSMA:
-        {
-          pendingPackets = &m_pendingCsmaPackets;
-          break;
-        }
-      case AnimationInterface::WIMAX:
-        {
-          pendingPackets = &m_pendingWimaxPackets;
-          break;
-        }
-      case AnimationInterface::LTE:
-        {
-          pendingPackets = &m_pendingLtePackets;
-          break;
-        }
-      case AnimationInterface::LRWPAN:
-        {
-          pendingPackets = &m_pendingLrWpanPackets;
-          break;
-        }
-      case AnimationInterface::WAVE:
-        {
-          pendingPackets = &m_pendingWavePackets;
-          break;
-        }
+    case AnimationInterface::WIFI:
+      {
+        pendingPackets = &m_pendingWifiPackets;
+        break;
+      }
+    case AnimationInterface::UAN:
+      {
+        pendingPackets = &m_pendingUanPackets;
+        break;
+      }
+    case AnimationInterface::CSMA:
+      {
+        pendingPackets = &m_pendingCsmaPackets;
+        break;
+      }
+    case AnimationInterface::WIMAX:
+      {
+        pendingPackets = &m_pendingWimaxPackets;
+        break;
+      }
+    case AnimationInterface::LTE:
+      {
+        pendingPackets = &m_pendingLtePackets;
+        break;
+      }
+    case AnimationInterface::LRWPAN:
+      {
+        pendingPackets = &m_pendingLrWpanPackets;
+        break;
+      }
+    case AnimationInterface::WAVE:
+      {
+        pendingPackets = &m_pendingWavePackets;
+        break;
+      }
     }
   return pendingPackets;
 
@@ -1354,70 +1384,70 @@
   std::string result = "Unknown";
   switch (protocolType)
     {
-      case AnimationInterface::WIFI:
-        {
-          result = "WIFI";
-          break;
-        }
-      case AnimationInterface::UAN:
-        {
-          result = "UAN";
-          break;
-        }
-      case AnimationInterface::CSMA:
-        {
-          result = "CSMA";
-          break;
-        }
-      case AnimationInterface::WIMAX:
-        {
-          result = "WIMAX";
-          break;
-        }
-      case AnimationInterface::LTE:
-        {
-          result = "LTE";
-          break;
-        }
-      case AnimationInterface::LRWPAN:
-        {
-          result = "LRWPAN";
-          break;
-        }
-      case AnimationInterface::WAVE:
-        {
-          result = "WAVE";
-          break;
-        }
+    case AnimationInterface::WIFI:
+      {
+        result = "WIFI";
+        break;
+      }
+    case AnimationInterface::UAN:
+      {
+        result = "UAN";
+        break;
+      }
+    case AnimationInterface::CSMA:
+      {
+        result = "CSMA";
+        break;
+      }
+    case AnimationInterface::WIMAX:
+      {
+        result = "WIMAX";
+        break;
+      }
+    case AnimationInterface::LTE:
+      {
+        result = "LTE";
+        break;
+      }
+    case AnimationInterface::LRWPAN:
+      {
+        result = "LRWPAN";
+        break;
+      }
+    case AnimationInterface::WAVE:
+      {
+        result = "WAVE";
+        break;
+      }
     }
   return result;
 }
 
 // Counters
 
-std::string 
+std::string
 AnimationInterface::CounterTypeToString (CounterType counterType)
 {
   std::string typeString = "unknown";
   switch (counterType)
     {
-      case UINT32_COUNTER:
-        {
-          typeString = "UINT32";
-          break;
-        } 
-      case DOUBLE_COUNTER:
-        {
-          typeString = "DOUBLE";
-          break;
-        } 
+    case UINT32_COUNTER:
+      {
+        typeString = "UINT32";
+        break;
+      }
+    case DOUBLE_COUNTER:
+      {
+        typeString = "DOUBLE";
+        break;
+      }
     }
   return typeString;
 }
 
 // General
 
-std::string 
+std::string
 AnimationInterface::GetPacketMetadata (Ptr<const Packet> p)
 {
   std::ostringstream oss;
@@ -1425,19 +1455,19 @@
   return oss.str ();
 }
 
-uint64_t 
+uint64_t
 AnimationInterface::GetTracePktCount ()
 {
   return m_currentPktCount;
 }
 
-void 
+void
 AnimationInterface::StopAnimation (bool onlyAnimation)
 {
   m_started = false;
   NS_LOG_INFO ("Stopping Animation");
   ResetAnimWriteCallback ();
-  if (m_f) 
+  if (m_f)
     {
       // Terminate the anim element
       WriteXmlClose ("anim");
@@ -1456,7 +1486,7 @@
     }
 }
 
-void 
+void
 AnimationInterface::StartAnimation (bool restart)
 {
   m_currentPktCount = 0;
